using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using HySoft.DBUtility;//Please add references
namespace HySoft.BaseCallCenter.DAL
{
	/// <summary>
	/// 数据访问类:T_Wo_WorkOrderTaskInfo
	/// </summary>
	public partial class T_Wo_WorkOrderTaskInfo
	{
		public T_Wo_WorkOrderTaskInfo()
		{}
		#region  Method



		/// <summary>
		/// 增加一条数据
		/// </summary>
		public int Add(HySoft.BaseCallCenter.Model.T_Wo_WorkOrderTaskInfo model)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("insert into T_Wo_WorkOrderTaskInfo(");
			strSql.Append("F_TASKID,F_WORKORDERID,F_OPTBY,F_OPTDATE,F_SUBSCRIBEDATE,F_SUBSCRIBESTATE,F_SUBSCRIBETIME,F_SUBSCRIBETIMEHOUR,F_SUBSCRIBEDES,F_SUBSCRIBEFAILINFO,F_ARRASSIGNUSER,F_ASSIGNTYPE,F_ASSIGNDES,F_REPLYINFO)");
			strSql.Append(" values (");
			strSql.Append("@F_TASKID,@F_WORKORDERID,@F_OPTBY,@F_OPTDATE,@F_SUBSCRIBEDATE,@F_SUBSCRIBESTATE,@F_SUBSCRIBETIME,@F_SUBSCRIBETIMEHOUR,@F_SUBSCRIBEDES,@F_SUBSCRIBEFAILINFO,@F_ARRASSIGNUSER,@F_ASSIGNTYPE,@F_ASSIGNDES,@F_REPLYINFO)");
			strSql.Append(";select @@IDENTITY");
			SqlParameter[] parameters = {
					new SqlParameter("@F_TASKID", SqlDbType.Int,4),
					new SqlParameter("@F_WORKORDERID", SqlDbType.Int,4),
					new SqlParameter("@F_OPTBY", SqlDbType.Int,4),
					new SqlParameter("@F_OPTDATE", SqlDbType.DateTime),
					new SqlParameter("@F_SUBSCRIBEDATE", SqlDbType.DateTime),
					new SqlParameter("@F_SUBSCRIBESTATE", SqlDbType.Int,4),
					new SqlParameter("@F_SUBSCRIBETIME", SqlDbType.Int,4),
					new SqlParameter("@F_SUBSCRIBETIMEHOUR", SqlDbType.VarChar,500),
					new SqlParameter("@F_SUBSCRIBEDES", SqlDbType.VarChar,500),
					new SqlParameter("@F_SUBSCRIBEFAILINFO", SqlDbType.VarChar,500),
					new SqlParameter("@F_ARRASSIGNUSER", SqlDbType.VarChar,500),
					new SqlParameter("@F_ASSIGNTYPE", SqlDbType.Int,4),
					new SqlParameter("@F_ASSIGNDES", SqlDbType.VarChar,500),
					new SqlParameter("@F_REPLYINFO", SqlDbType.VarChar,4000)};
			parameters[0].Value = model.F_TASKID;
			parameters[1].Value = model.F_WORKORDERID;
			parameters[2].Value = model.F_OPTBY;
			parameters[3].Value = model.F_OPTDATE;
			parameters[4].Value = model.F_SUBSCRIBEDATE;
			parameters[5].Value = model.F_SUBSCRIBESTATE;
			parameters[6].Value = model.F_SUBSCRIBETIME;
			parameters[7].Value = model.F_SUBSCRIBETIMEHOUR;
			parameters[8].Value = model.F_SUBSCRIBEDES;
			parameters[9].Value = model.F_SUBSCRIBEFAILINFO;
			parameters[10].Value = model.F_ARRASSIGNUSER;
			parameters[11].Value = model.F_ASSIGNTYPE;
			parameters[12].Value = model.F_ASSIGNDES;
			parameters[13].Value = model.F_REPLYINFO;

			object obj = DbHelperSQL.GetSingle(strSql.ToString(),parameters);
			if (obj == null)
			{
				return 0;
			}
			else
			{
				return Convert.ToInt32(obj);
			}
		}
		/// <summary>
		/// 更新一条数据
		/// </summary>
		public bool Update(HySoft.BaseCallCenter.Model.T_Wo_WorkOrderTaskInfo model)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("update T_Wo_WorkOrderTaskInfo set ");
			strSql.Append("F_TASKID=@F_TASKID,");
			strSql.Append("F_WORKORDERID=@F_WORKORDERID,");
			strSql.Append("F_OPTBY=@F_OPTBY,");
			strSql.Append("F_OPTDATE=@F_OPTDATE,");
			strSql.Append("F_SUBSCRIBEDATE=@F_SUBSCRIBEDATE,");
			strSql.Append("F_SUBSCRIBESTATE=@F_SUBSCRIBESTATE,");
			strSql.Append("F_SUBSCRIBETIME=@F_SUBSCRIBETIME,");
			strSql.Append("F_SUBSCRIBETIMEHOUR=@F_SUBSCRIBETIMEHOUR,");
			strSql.Append("F_SUBSCRIBEDES=@F_SUBSCRIBEDES,");
			strSql.Append("F_SUBSCRIBEFAILINFO=@F_SUBSCRIBEFAILINFO,");
			strSql.Append("F_ARRASSIGNUSER=@F_ARRASSIGNUSER,");
			strSql.Append("F_ASSIGNTYPE=@F_ASSIGNTYPE,");
			strSql.Append("F_ASSIGNDES=@F_ASSIGNDES,");
			strSql.Append("F_REPLYINFO=@F_REPLYINFO");
			strSql.Append(" where F_TASKINFOID=@F_TASKINFOID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_TASKID", SqlDbType.Int,4),
					new SqlParameter("@F_WORKORDERID", SqlDbType.Int,4),
					new SqlParameter("@F_OPTBY", SqlDbType.Int,4),
					new SqlParameter("@F_OPTDATE", SqlDbType.DateTime),
					new SqlParameter("@F_SUBSCRIBEDATE", SqlDbType.DateTime),
					new SqlParameter("@F_SUBSCRIBESTATE", SqlDbType.Int,4),
					new SqlParameter("@F_SUBSCRIBETIME", SqlDbType.Int,4),
					new SqlParameter("@F_SUBSCRIBETIMEHOUR", SqlDbType.VarChar,500),
					new SqlParameter("@F_SUBSCRIBEDES", SqlDbType.VarChar,500),
					new SqlParameter("@F_SUBSCRIBEFAILINFO", SqlDbType.VarChar,500),
					new SqlParameter("@F_ARRASSIGNUSER", SqlDbType.VarChar,500),
					new SqlParameter("@F_ASSIGNTYPE", SqlDbType.Int,4),
					new SqlParameter("@F_ASSIGNDES", SqlDbType.VarChar,500),
					new SqlParameter("@F_REPLYINFO", SqlDbType.VarChar,4000),
					new SqlParameter("@F_TASKINFOID", SqlDbType.Int,4)};
			parameters[0].Value = model.F_TASKID;
			parameters[1].Value = model.F_WORKORDERID;
			parameters[2].Value = model.F_OPTBY;
			parameters[3].Value = model.F_OPTDATE;
			parameters[4].Value = model.F_SUBSCRIBEDATE;
			parameters[5].Value = model.F_SUBSCRIBESTATE;
			parameters[6].Value = model.F_SUBSCRIBETIME;
			parameters[7].Value = model.F_SUBSCRIBETIMEHOUR;
			parameters[8].Value = model.F_SUBSCRIBEDES;
			parameters[9].Value = model.F_SUBSCRIBEFAILINFO;
			parameters[10].Value = model.F_ARRASSIGNUSER;
			parameters[11].Value = model.F_ASSIGNTYPE;
			parameters[12].Value = model.F_ASSIGNDES;
			parameters[13].Value = model.F_REPLYINFO;
			parameters[14].Value = model.F_TASKINFOID;

			int rows=DbHelperSQL.ExecuteSql(strSql.ToString(),parameters);
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}

		/// <summary>
		/// 删除一条数据
		/// </summary>
		public bool Delete(int F_TASKINFOID)
		{
			
			StringBuilder strSql=new StringBuilder();
			strSql.Append("delete from T_Wo_WorkOrderTaskInfo ");
			strSql.Append(" where F_TASKINFOID=@F_TASKINFOID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_TASKINFOID", SqlDbType.Int,4)
};
			parameters[0].Value = F_TASKINFOID;

			int rows=DbHelperSQL.ExecuteSql(strSql.ToString(),parameters);
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		/// <summary>
		/// 批量删除数据
		/// </summary>
		public bool DeleteList(string F_TASKINFOIDlist )
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("delete from T_Wo_WorkOrderTaskInfo ");
			strSql.Append(" where F_TASKINFOID in ("+F_TASKINFOIDlist + ")  ");
			int rows=DbHelperSQL.ExecuteSql(strSql.ToString());
			if (rows > 0)
			{
				return true;
			}
			else
			{
				return false;
			}
		}


		/// <summary>
		/// 得到一个对象实体
		/// </summary>
		public HySoft.BaseCallCenter.Model.T_Wo_WorkOrderTaskInfo GetModel(int F_TASKINFOID)
		{
			
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select  top 1 F_TASKINFOID,F_TASKID,F_WORKORDERID,F_OPTBY,F_OPTDATE,F_SUBSCRIBEDATE,F_SUBSCRIBESTATE,F_SUBSCRIBETIME,F_SUBSCRIBETIMEHOUR,F_SUBSCRIBEDES,F_SUBSCRIBEFAILINFO,F_ARRASSIGNUSER,F_ASSIGNTYPE,F_ASSIGNDES,F_REPLYINFO from T_Wo_WorkOrderTaskInfo ");
			strSql.Append(" where F_TASKINFOID=@F_TASKINFOID");
			SqlParameter[] parameters = {
					new SqlParameter("@F_TASKINFOID", SqlDbType.Int,4)
};
			parameters[0].Value = F_TASKINFOID;

			HySoft.BaseCallCenter.Model.T_Wo_WorkOrderTaskInfo model=new HySoft.BaseCallCenter.Model.T_Wo_WorkOrderTaskInfo();
			DataSet ds=DbHelperSQL.Query(strSql.ToString(),parameters);
			if(ds.Tables[0].Rows.Count>0)
			{
				if(ds.Tables[0].Rows[0]["F_TASKINFOID"]!=null && ds.Tables[0].Rows[0]["F_TASKINFOID"].ToString()!="")
				{
					model.F_TASKINFOID=int.Parse(ds.Tables[0].Rows[0]["F_TASKINFOID"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_TASKID"]!=null && ds.Tables[0].Rows[0]["F_TASKID"].ToString()!="")
				{
					model.F_TASKID=int.Parse(ds.Tables[0].Rows[0]["F_TASKID"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_WORKORDERID"]!=null && ds.Tables[0].Rows[0]["F_WORKORDERID"].ToString()!="")
				{
					model.F_WORKORDERID=int.Parse(ds.Tables[0].Rows[0]["F_WORKORDERID"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_OPTBY"]!=null && ds.Tables[0].Rows[0]["F_OPTBY"].ToString()!="")
				{
					model.F_OPTBY=int.Parse(ds.Tables[0].Rows[0]["F_OPTBY"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_OPTDATE"]!=null && ds.Tables[0].Rows[0]["F_OPTDATE"].ToString()!="")
				{
					model.F_OPTDATE=DateTime.Parse(ds.Tables[0].Rows[0]["F_OPTDATE"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_SUBSCRIBEDATE"]!=null && ds.Tables[0].Rows[0]["F_SUBSCRIBEDATE"].ToString()!="")
				{
					model.F_SUBSCRIBEDATE=DateTime.Parse(ds.Tables[0].Rows[0]["F_SUBSCRIBEDATE"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_SUBSCRIBESTATE"]!=null && ds.Tables[0].Rows[0]["F_SUBSCRIBESTATE"].ToString()!="")
				{
					model.F_SUBSCRIBESTATE=int.Parse(ds.Tables[0].Rows[0]["F_SUBSCRIBESTATE"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_SUBSCRIBETIME"]!=null && ds.Tables[0].Rows[0]["F_SUBSCRIBETIME"].ToString()!="")
				{
					model.F_SUBSCRIBETIME=int.Parse(ds.Tables[0].Rows[0]["F_SUBSCRIBETIME"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_SUBSCRIBETIMEHOUR"]!=null && ds.Tables[0].Rows[0]["F_SUBSCRIBETIMEHOUR"].ToString()!="")
				{
					model.F_SUBSCRIBETIMEHOUR=ds.Tables[0].Rows[0]["F_SUBSCRIBETIMEHOUR"].ToString();
				}
				if(ds.Tables[0].Rows[0]["F_SUBSCRIBEDES"]!=null && ds.Tables[0].Rows[0]["F_SUBSCRIBEDES"].ToString()!="")
				{
					model.F_SUBSCRIBEDES=ds.Tables[0].Rows[0]["F_SUBSCRIBEDES"].ToString();
				}
				if(ds.Tables[0].Rows[0]["F_SUBSCRIBEFAILINFO"]!=null && ds.Tables[0].Rows[0]["F_SUBSCRIBEFAILINFO"].ToString()!="")
				{
					model.F_SUBSCRIBEFAILINFO=ds.Tables[0].Rows[0]["F_SUBSCRIBEFAILINFO"].ToString();
				}
				if(ds.Tables[0].Rows[0]["F_ARRASSIGNUSER"]!=null && ds.Tables[0].Rows[0]["F_ARRASSIGNUSER"].ToString()!="")
				{
					model.F_ARRASSIGNUSER=ds.Tables[0].Rows[0]["F_ARRASSIGNUSER"].ToString();
				}
				if(ds.Tables[0].Rows[0]["F_ASSIGNTYPE"]!=null && ds.Tables[0].Rows[0]["F_ASSIGNTYPE"].ToString()!="")
				{
					model.F_ASSIGNTYPE=int.Parse(ds.Tables[0].Rows[0]["F_ASSIGNTYPE"].ToString());
				}
				if(ds.Tables[0].Rows[0]["F_ASSIGNDES"]!=null && ds.Tables[0].Rows[0]["F_ASSIGNDES"].ToString()!="")
				{
					model.F_ASSIGNDES=ds.Tables[0].Rows[0]["F_ASSIGNDES"].ToString();
				}
				if(ds.Tables[0].Rows[0]["F_REPLYINFO"]!=null && ds.Tables[0].Rows[0]["F_REPLYINFO"].ToString()!="")
				{
					model.F_REPLYINFO=ds.Tables[0].Rows[0]["F_REPLYINFO"].ToString();
				}
				return model;
			}
			else
			{
				return null;
			}
		}

		/// <summary>
		/// 获得数据列表
		/// </summary>
		public DataSet GetList(string strWhere)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select F_TASKINFOID,F_TASKID,F_WORKORDERID,F_OPTBY,F_OPTDATE,F_SUBSCRIBEDATE,F_SUBSCRIBESTATE,F_SUBSCRIBETIME,F_SUBSCRIBETIMEHOUR,F_SUBSCRIBEDES,F_SUBSCRIBEFAILINFO,F_ARRASSIGNUSER,F_ASSIGNTYPE,F_ASSIGNDES,F_REPLYINFO ");
			strSql.Append(" FROM T_Wo_WorkOrderTaskInfo ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			return DbHelperSQL.Query(strSql.ToString());
		}

		/// <summary>
		/// 获得前几行数据
		/// </summary>
		public DataSet GetList(int Top,string strWhere,string filedOrder)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select ");
			if(Top>0)
			{
				strSql.Append(" top "+Top.ToString());
			}
			strSql.Append(" F_TASKINFOID,F_TASKID,F_WORKORDERID,F_OPTBY,F_OPTDATE,F_SUBSCRIBEDATE,F_SUBSCRIBESTATE,F_SUBSCRIBETIME,F_SUBSCRIBETIMEHOUR,F_SUBSCRIBEDES,F_SUBSCRIBEFAILINFO,F_ARRASSIGNUSER,F_ASSIGNTYPE,F_ASSIGNDES,F_REPLYINFO ");
			strSql.Append(" FROM T_Wo_WorkOrderTaskInfo ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			strSql.Append(" order by " + filedOrder);
			return DbHelperSQL.Query(strSql.ToString());
		}

		/// <summary>
		/// 获取记录总数
		/// </summary>
		public int GetRecordCount(string strWhere)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("select count(1) FROM T_Wo_WorkOrderTaskInfo ");
			if(strWhere.Trim()!="")
			{
				strSql.Append(" where "+strWhere);
			}
			object obj = DbHelperSQL.GetSingle(strSql.ToString());
			if (obj == null)
			{
				return 0;
			}
			else
			{
				return Convert.ToInt32(obj);
			}
		}
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
		{
			StringBuilder strSql=new StringBuilder();
			strSql.Append("SELECT * FROM ( ");
			strSql.Append(" SELECT ROW_NUMBER() OVER (");
			if (!string.IsNullOrEmpty(orderby.Trim()))
			{
				strSql.Append("order by T." + orderby );
			}
			else
			{
				strSql.Append("order by T.F_TASKINFOID desc");
			}
			strSql.Append(")AS Row, T.*  from T_Wo_WorkOrderTaskInfo T ");
			if (!string.IsNullOrEmpty(strWhere.Trim()))
			{
				strSql.Append(" WHERE " + strWhere);
			}
			strSql.Append(" ) TT");
			strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
			return DbHelperSQL.Query(strSql.ToString());
		}

		/*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Wo_WorkOrderTaskInfo";
			parameters[1].Value = "F_TASKINFOID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

		#endregion  Method
	}
}

